typedef unsigned char byte;

#define ozis770() (MODEL770PC==ozdetectmodel())

unsigned ozgetauxsize(void);
void ozwriteauxmem(unsigned address,void *data,unsigned length);
void ozreadauxmem(unsigned address,void *data,unsigned length);
void ozwriteauxword(unsigned address,unsigned value);
void ozwriteauxbyte(unsigned address,byte value);
byte ozreadauxbyte(unsigned address);
unsigned ozreadauxword(unsigned address);
ozfarmemcpy(unsigned dest_page,unsigned dest_offset,unsigned src_page,
  unsigned src_offset,unsigned length);


void ozsetactivepage(byte page);
void ozsetdisplaypage(byte page);
byte ozgetactivepage(void);
byte ozgetdisplaypage(void);
void ozdisplayactivepage(void);
void ozactivatedisplaypage(void);
void ozcopypage(byte dest, byte src);
void ozswapactivedisplaypages(void);
extern unsigned __ozactivepage;
#define MAX_DISPLAYPAGES


void ozsound(unsigned div);
void ozquiet(void);

int ozwritefile(void *data, unsigned length, byte type);
void ozexitto(unsigned key);
void oztogglelight(void);
void ozsetlight(byte l);
int ozgetlight(void);
void ozdisableinterrupts(void);
void ozenableinterrupts(void);
void ozfast(void);
void ozslow(void);
void ozblankscreen(void);
void ozunblankscreen(void);
char *ozputsgetend(void);
void ozcls(void);
int _ozpoint(byte x, byte y, byte color);
int ozpoint(int x, int y, byte color);
void ozcircle(int x,int y,byte r,byte color);
void ozline(int x,int y,int x2,int y2,byte color);
void _ozline(byte x,byte y,byte x2,byte y2,byte color);
void _ozvline(byte x,byte y,byte len,byte color);
void ozdisplayorbyte(unsigned offset, byte v);
void ozdisplayputbyte(unsigned offset, byte v);
void ozdisplayandbyte(unsigned offset, byte v);
byte ozdisplayinbyte(unsigned offset);
int ozgetpoint(int x, int y);
void ozbox(int x, int y, int width, int height);

void _ozcustomisr(void);
void ozclick(byte state);

void ozkeyclear(void);
void ozdatabits(byte databits);
int ozserialgetc(void);
void ozsetbaud(unsigned baud);
unsigned ozgetbaud(void);
void ozstopbits(char stopbits);
void ozparity(byte parity);
byte ozgetlcr(void);
void ozsetlcr(byte lcr);
int ozserialin(void);
void ozserialout(char c);
void ozserinton(void);
void ozserintoff(void);
int oznkeyhit(void);
int ozkeyhit(void);
unsigned ozgetch(void);
unsigned ozngetch(void);
unsigned ngetch(void);
void ozungetch(unsigned key);
void ozkbdon(void);
void ozkbdoff(void);
void ozscroll(unsigned numbytes);
void ozscrollclear(void);
void ozdelay(unsigned d);
int ozputs_system(int x, int y, char *string);
int ozputs(int x, int y, char *string);
void ozfont(char fontnum);
unsigned ozsec(void);
unsigned ozmin(void);
unsigned ozhour(void);
unsigned ozweekday(void);
unsigned ozmonth(void);
unsigned ozday(void);
unsigned ozyear(void);
byte ozkeyupper(byte mask);
byte ozkeylower(byte mask);
int ozputch(int x, int y, char c);
void exit(int ignored_exit_code);
byte ozportin(byte port);
void ozportout(byte port, byte value);
typedef void (*ozexitfunction_t)(void);
int ozaddexitfunction(ozexitfunction_t f);
typedef void (*ozisr)(void);
int ozsetisr(ozisr f);	 /* set custom ISR with paging */
int _ozsetisr(ozisr f);  /* same, but no paging--routine must always
							be paged in */
void ozisroff(void);      /* turn off custom ISR (set im 1) */
unsigned getch(void);
int kbhit(void);
int nkbhit(void);

void ozsound(unsigned value);
void ozquiet(void);
void ozinitsound(void);

/* some stuff for backwards compatibility -- deprecated, do not use */
#define ozsec1() (ozsec()%10)
#define ozsec2() (ozsec()/10)
#define ozmin1() (ozmin()%10)
#define ozmin2() (ozmin()/10)

/* for ozgetch() */
#define KEY_LEFT_SHIFT	0x0800
#define KEY_RIGHT_SHIFT 0x8036
#define KEY_2ND 		0x8037
#define KEY_LOWER_ESC	0x8058
#define KEY_UPPER_ESC	0x8067
#define KEY_NEWLINE 	0x0D
#define KEY_MYPROGRAMS	0x7015
#define KEY_MAIN		0x7025
#define KEY_USER1		0x70E9
#define KEY_USER2		0x70EA
#define KEY_USER3		0x70EB
#define KEY_TELEPHONE	KEY_USER1
#define KEY_SCHEDULE    KEY_USER2
#define KEY_CALENDAR    KEY_USER2
#define KEY_MEMO		KEY_USER3
#define KEY_LOWER_MENU	0x8032
#define KEY_NEW 		0x8033
#define KEY_BACKSPACE   0x8057
#define KEY_CATEGORY	0x8035
#define KEY_LOWER_ENTER 0x8038
#define KEY_POWER		0x803A
#define KEY_BACKLIGHT	0x803B
#define KEY_DOWN		0x8041
#define KEY_UP			0x8040
#define KEY_LEFT		0x8042
#define KEY_RIGHT		0x8043
#define KEY_PAGEUP		0x8044
#define KEY_PAGEDOWN	0x8045
#define KEY_DEL 		0x8057
#define KEY_UPPER_ENTER 0x8066
#define KEY_UPPER_MENU	0x8068

/* for getch() */
#define NO_KEY		 0xFFFF
#define MASKSHIFT	 0x0800
#define MASKCATEGORY 0x0400
#define MASKCTRL	 0x0200
#define MASK2ND 	 0x0100


/* for ozparity() */
#define NO_PARITY 0
#define ODD_PARITY 0x08
#define EVEN_PARITY 0x18
#define HIGH_PARITY 0x28
#define LOW_PARITY	0x38

/* for ozstopbits() */
#define ONE_STOP_BIT 0
#define TWO_STOP_BITS 4
#define ONE_POINT_FIVE_STOP_BITS 4

/* for ozbaud() */
#define BAUD76800 2
#define BAUD51200 3
#define BAUD38400 4
#define BAUD30720 5
#define BAUD25600 6
#define BAUD19200 8
#define BAUD9600 16
#define BAUD4800 32
#define BAUD2400 64
#define BAUD1200 128
#define BAUD600 256
#define BAUD300 512
#define BAUD150 1024

/* for ozdatabits() */
#define DATABITS5 0
#define DATABITS6 1
#define DATABITS7 2
#define DATABITS8 3

/* for ozxxxlcr() */
#define BREAKSTATE 0x40

#define WHITE 0
#define BLACK 1
#define XOR   2

#define FILL   4
#define UNFILL 0

#define BACKLIGHTMASK 0x40
#define BACKLIGHTSAVEMASK 0x08
extern byte _ozbacklight,_ozbacklight_save;

extern unsigned _oz64hz_word;
extern unsigned long _oz64hz_dword;

/* for ozfindnext */

/* These are third characters of the type identifiers, which, luckily,
are unique. */
#define TYPE_MEMO 'M'
#define TYPE_SCHEDULE 'C'
#define TYPE_SYSTEM 'Y'
#define TYPE_TELEPHONE 'E'
#define TYPE_EXPENSES 'P'
#define TYPE_BASIC 'I'
#define TYPE_ANNIVERSARY 'N'
#define TYPE_TODO 'D'

/* These are used by writing and deleting system functions */
#define TYPENUM_SYSTEM    0
#define TYPENUM_TELEPHONE 1
#define TYPENUM_MEMO      2
#define TYPENUM_SCHEDULE  3
#define TYPENUM_ANNIVERSARY 4
#define TYPENUM_TODO      5
#define TYPENUM_EXPENSES  6
#define TYPENUM_BASIC     7

unsigned ozfindnext(char type, unsigned *start_page, unsigned
  *start_offset, unsigned *recnum);
char *ozloadcluster(unsigned loc);
unsigned ozinclocation(unsigned loc);
unsigned ozfindmemo(char *memo, unsigned *start_page, unsigned
  *start_offset, unsigned *recnum);
unsigned ozfindfileid(unsigned fileid, unsigned *start_page, unsigned
  *start_offset, unsigned *recnum);
unsigned ozfindfilename(char *filename, unsigned *start_page, unsigned
  *start_offset, unsigned *recnum);
unsigned ozunlink(byte typenum, unsigned recnum);

#define FONT_PC_NORMAL 1
#define FONT_PC_LARGE 0
#define FONT_OZ_NORMAL 3
#define FONT_OZ_LARGE 2

extern unsigned __ozfileowner;

#define O_RDONLY 1
#define O_WRONLY 2
#define MAX_FILENAMELEN 23
#define MAX_FILES 4
#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2


int close(int handle);
int write(int handle, void *data, int length);
int read(int handle, void *data, int length);
int open(char *_name, int mode);
long lseek(int handle, long offset, int fromwhere);
int access(char *name);
int unlink(char *name);
int ozunlinkallowned(void);
void closeall(void);
void ozsetowner(unsigned o);
unsigned ozgetowner(void);

byte ozgetcontrast(void);
void ozsetcontrast(byte c);

#define MAX_CONTRAST 0x3F

byte ozdetectmodel(void);

#define MODELMASK_MEMORY 1
#define MODELMASK_770    2
#define MODELMASK_M      4
#define MODEL700PC 0
#define MODEL730PC 0
#define MODEL750PC MODELMASK_MEMORY
#define MODEL770PC (MODELMASK_MEMORY | MODELMASK_770)
#define MODEL700M  MODELMASK_M
#define MODEL750M  (MODELMASK_MEMORY | MODELMASK_M)
#define MODEL770M  (MODELMASK_MEMORY | MODELMASK_770 | MODEMASK_M)
                      /* 770M NOT YET EXISTENT OR DETECTED, BUT IF IT IS */
                      /* MADE, THAT WILL BE ITS MODEL NUMBER */
